package ShowXPath.GUI;

import java.awt.*;
import java.io.*;
import java.util.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.tree.*;
import javax.swing.tree.DefaultMutableTreeNode;
import ShowXPath.StackNode.*;
import ShowXPath.TreeNode.*;
import ShowXPath.*;


public class ContextTree extends javax.swing.JPanel
{
	DefaultMutableTreeNode treeRoot;
	DefaultTreeModel treeModel;
	LStackNode _node = new LNodeset();
	JTree tree = new javax.swing.JTree();
	Main _main;

	private JTree getTree()
	{
		return tree;
	}

	public void addTreeSelectionListener(Object obj)
	{
		tree.addTreeSelectionListener(
			(javax.swing.event.TreeSelectionListener)obj
			);
	}

	public java.lang.Object getLastSelectedPathComponent()
	{
		return tree.getLastSelectedPathComponent();
	}

	public ContextTree(Main main)
	{
		_main = main;
		treeRoot = new DefaultMutableTreeNode("/");
		treeModel = new DefaultTreeModel(treeRoot);
		tree = new JTree(treeModel);
		setLayout(new BorderLayout(0,0));
		setBackground(java.awt.Color.white);
		add("Center", tree);
		tree.setBounds(0,0,700,500);
		tree.getSelectionModel().setSelectionMode(
			TreeSelectionModel.SINGLE_TREE_SELECTION);
		tree.putClientProperty("JTree.lineStyle", "Angled");
		tree.addTreeSelectionListener(new TreeSelectionListener() 
			{
				public void valueChanged(TreeSelectionEvent e)
				{
					TreePath t = e.getNewLeadSelectionPath();
					if (t != null)
					{
						DefaultMutableTreeNode node =
							(DefaultMutableTreeNode) t.getLastPathComponent();
						if (node.getUserObject() instanceof Context)
						{
							_main.setContextDisplay((Context)node.getUserObject());
						}
					}
				}
			});
	}

	public void addRoot(Context context)
	{
		this.removeAll();
		DefaultMutableTreeNode node = new DefaultMutableTreeNode(context);
		treeModel.insertNodeInto(node, treeRoot, 0);
		context.setTreeNode(node);
		treeModel.reload();
		for (Enumeration e = treeRoot.depthFirstEnumeration(); e.hasMoreElements();)
		{
			DefaultMutableTreeNode n = (DefaultMutableTreeNode) e.nextElement();
			tree.expandPath(new TreePath(n.getPath()));
		}
	}

	public DefaultMutableTreeNode getRoot()
	{
		return treeRoot;
	}

	public DefaultMutableTreeNode addChild(DefaultMutableTreeNode treeNode, Context child)
	{
		DefaultMutableTreeNode n = new DefaultMutableTreeNode(child);
		treeModel.insertNodeInto(n, treeNode, treeModel.getChildCount(treeNode));
		child.setTreeNode(n);
		treeModel.reload();
		for (Enumeration e = treeRoot.depthFirstEnumeration(); e.hasMoreElements();)
		{
			DefaultMutableTreeNode nnn = (DefaultMutableTreeNode) e.nextElement();
			tree.expandPath(new TreePath(nnn.getPath()));
		}
		return n;
	}
	
	public void removeChild(DefaultMutableTreeNode treeNode)
	{
		Context context = (Context)treeNode.getUserObject();
		_main.updateContextDisplay(context);
		treeModel.removeNodeFromParent(treeNode);
		treeModel.reload();
		for (Enumeration e = treeRoot.depthFirstEnumeration(); e.hasMoreElements();)
		{
			DefaultMutableTreeNode n = (DefaultMutableTreeNode) e.nextElement();
			tree.expandPath(new TreePath(n.getPath()));
		}
	}
	
	public void removeAll()
	{
		if (treeRoot.getChildCount() != 0)
		{
			DefaultMutableTreeNode realRoot = (DefaultMutableTreeNode)treeRoot.getChildAt(0);
			for (Enumeration e = realRoot.depthFirstEnumeration(); e.hasMoreElements();)
			{
				DefaultMutableTreeNode n = (DefaultMutableTreeNode) e.nextElement();
				Context context = (Context)n.getUserObject();
				_main.updateContextDisplay(context);
				treeModel.removeNodeFromParent(n);
			}
			treeModel.reload();
		for (Enumeration e = treeRoot.depthFirstEnumeration(); e.hasMoreElements();)
		{
			DefaultMutableTreeNode n = (DefaultMutableTreeNode) e.nextElement();
			tree.expandPath(new TreePath(n.getPath()));
		}
		}
	}

}
