package ShowXPath.StackNode;

import java.util.*;
import java.io.*;
import ShowXPath.TreeNode.*;

public class LNodeset extends LinkedList implements LStackNode
{
	private final static String _type = "LNodeset";

	public void addSortAll(LNodeset nodeset)
	{
		ListIterator j = nodeset.listIterator();
		while (j.hasNext())
		{
			addSort((LTreeNode)j.next());
		}
	}

	public void addSort(LTreeNode node)
	{
		int index = 0;
		ListIterator i = listIterator();
		while (i.hasNext())
		{
			LTreeNode n = (LTreeNode)i.next();
			if (n.getID() >= node.getID())
			{
				break;
			}
			index++;
		}
		add(index, node);
	}

	public String type()
	{
		return _type;
	}

	public LBoolean toLBoolean()
	{
		if (this.size() > 0)
		{
			return new LBoolean(true);
		}
		else
		{
			return new LBoolean(false);
		}
	}

	public LNumber toLNumber()
	{
		LTreeNode n = (LTreeNode) getFirst();
		LString s = new LString(n.toString());
		
		return new LNumber(s.toString());
	}

	public String getStringValue()
	{
		if (size() > 0)
		{
			return ((LTreeNode)getFirst()).getStringValue();
		}
		else
		{
			return "";
		}
	}

	public LString toLString()
	{
		return new LString(((LTreeNode)getFirst()).getStringValue());
	}
		
	public String showNode()
	{
		String s = "";
		ListIterator i = listIterator();
		while (i.hasNext())
		{
			s = s + "'" + ((LTreeNode)i.next()).showNode() + "'\n";
		}
		return s;
	}

	public String toString()
	{
		return showNode();
	}

	public void removeDuplicates()
	{
		for (int i = 0; i < size(); i++)
		{
			int li = lastIndexOf(get(i));
			if (li != i)
			{
				remove(li);
			}
		}
	}

	private void print(String string)
	{
		//System.out.println("LNodeset: " + string);
	}
	
	public boolean equals(LStackNode node)
	{
		print("equals");
		if (node instanceof LNodeset)
		{
			print("The second operand is also a nodeset");
			ListIterator i = this.listIterator();

			while (i.hasNext())
			{
				ListIterator j = ((LNodeset)node).listIterator();
				String s = ((LTreeNode)i.next()).getStringValue();
				while (j.hasNext())
				{
					String t = ((LTreeNode)j.next()).getStringValue();
					if (s.equals(t))
					{
						return true;
					}
				}
			}
			return false;
		}
		else if (node instanceof LBoolean)
		{
			return node.equals((LNodeset)this);
		}
		else if (node instanceof LString)
		{
			return node.equals((LNodeset)this);
		}
		else if (node instanceof LNumber)
		{
			return node.equals((LNodeset)this);
		}
		else
		{
			return false;
		}
	}
	
	public boolean less(LStackNode node)
	{
		if (node instanceof LNodeset)
		{
			ListIterator i = ((LNodeset)node).listIterator();

			while (i.hasNext())
			{
				if (new LString(((LTreeNode)i.next()).toString()).greaterEquals((LNodeset)this))
				{
					return true;
				}
			}
			return false;
		}
		else if (node instanceof LBoolean)
		{
			return node.greaterEquals((LNodeset)this);
		}
		else if (node instanceof LString)
		{
			return node.greaterEquals((LNodeset)this);
		}
		else if (node instanceof LNumber)
		{
			return node.greaterEquals((LNodeset)this);
		}
		else
		{
			return false;
		}
	}

	public boolean greater(LStackNode node)
	{
		if (node instanceof LNodeset)
		{
			ListIterator i = ((LNodeset)node).listIterator();

			while (i.hasNext())
			{
				if (new LString(((LTreeNode)i.next()).toString()).lessEquals((LNodeset)this))
				{
					return true;
				}
			}
			return false;
		}
		else if (node instanceof LBoolean)
		{
			return node.lessEquals((LNodeset)this);
		}
		else if (node instanceof LString)
		{
			return node.lessEquals((LNodeset)this);
		}
		else if (node instanceof LNumber)
		{
			return node.lessEquals((LNodeset)this);
		}
		else
		{
			return false;
		}
	}

	public boolean lessEquals(LStackNode node)
	{
		if (node instanceof LNodeset)
		{
			ListIterator i = ((LNodeset)node).listIterator();

			while (i.hasNext())
			{
				if (new LString(((LTreeNode)i.next()).toString()).greater((LNodeset)this))
				{
					return true;
				}
			}
			return false;
		}
		else if (node instanceof LBoolean)
		{
			return node.greater((LNodeset)this);
		}
		else if (node instanceof LString)
		{
			return node.greater((LNodeset)this);
		}
		else if (node instanceof LNumber)
		{
			return node.greater((LNodeset)this);
		}
		else
		{
			return false;
		}
	}

	public boolean greaterEquals(LStackNode node)
	{
		if (node instanceof LNodeset)
		{
			ListIterator i = ((LNodeset)node).listIterator();

			while (i.hasNext())
			{
				if (new LString(((LTreeNode)i.next()).toString()).less((LNodeset)this))
				{
					return true;
				}
			}
			return false;
		}
		else if (node instanceof LBoolean)
		{
			return node.less((LNodeset)this);
		}
		else if (node instanceof LString)
		{
			return node.less((LNodeset)this);
		}
		else if (node instanceof LNumber)
		{
			return node.less((LNodeset)this);
		}
		else
		{
			return false;
		}
	}
}
